#include <iostream>

using namespace std;

long long mod = 1000000007;
long long bin[1010][1010];

long long binom(int i, int j){
	//cout << i << " " << j << endl;
	if(i == 0 || j == 0 || i == j) return (bin[i][j] = 1);
	if(bin[i][j] != -1) return bin[i][j];
	return bin[i][j] = ((binom(i - 1, j) + binom(i - 1, j - 1)) % mod);
}

int main(){
	for(int i = 0; i < 1010; ++i){
		for(int j = 0; j < 1010; ++j){
			bin[i][j] = -1;
		}
	}

	ios::sync_with_stdio(0);
	
	long long A, B, K, C;

	cin >> A >> B >> K >> C;
	long long out = 0;
	/*
	for(int i = 1; i < 10; ++i){
		for(int j = 0; j <= i; ++j){
			cout << binom(i, j) << endl;
		}
	}
*/
	for(int i = 0; i <= K; ++i){
		//cout << binom(K, i) << endl;
		out = (out + ((i * binom(K, i)) % mod)) % mod;
	}
	if(C != A && C != B)
		cout << 0 << endl;
	else if(A == B)
		cout << K << endl;
	else
		cout << out << endl;

	return 0;
}
