#include <cstdio>
#include <vector>
#include <set>

using namespace std;

bool isPointAt[2002][2002];

int main(){
	int n;	
	scanf("%d", &n);
	vector<int> points;
	set<pair <int, int> > st;
	for(int i = 0; i < n; ++i){
		int a, b;
		scanf("%d%d", &a, &b);
		a += 1000; b += 1000;
		isPointAt[a][b] = true;
		points.push_back(a);
		points.push_back(b);
	}

	//int out = 0;

	for(int i = 0; i < 2 * n; i += 2){
		for(int j = 0; j < 2 * n; j += 2){
			if(i == j) continue;
			int deltaX = points[j] - points[i];
			int deltaY = points[j + 1] - points[i + 1];
			bool ok = true;
			for(int k = 0; k < 2 * n; k += 2){
				if(points[k] + deltaX > 2000 || points[k] + deltaX < 0){
					if(points[k] - deltaX > 2000 || points[k] - deltaX < 0){
						ok = false;
					}
					else if(points[k + 1] - deltaY > 2000 || points[k + 1] - deltaY < 0) ok = false;
					else ok = isPointAt[points[k] - deltaX][points[k + 1] - deltaY];
				}
				else if(points[k + 1] + deltaY > 2000 || points[k + 1] + deltaY < 0){
					if(points[k] - deltaX > 2000 || points[k] - deltaX < 0){
						ok = false;
					}
					else if(points[k + 1] - deltaY > 2000 || points[k + 1] - deltaY < 0) ok = false;
					else ok = isPointAt[points[k] - deltaX][points[k + 1] - deltaY];
				}
				else{
					if(isPointAt[points[k] + deltaX][points[k + 1] + deltaY]) ok = true;
					else{
						if(points[k] - deltaX > 2000 || points[k] - deltaX < 0){
							ok = false;
						}
						else if(points[k + 1] - deltaY > 2000 || points[k + 1] - deltaY < 0) ok = false;
						else ok = isPointAt[points[k] - deltaX][points[k + 1] - deltaY];
					}
				}
				/*
				if(!(isPointAt[points[k] + deltaX][points[k + 1] + deltaY] || 
				     isPointAt[points[k] - deltaX][points[k + 1] - deltaY])){
					ok = false; break;
				}*/
				if(!ok) break;
			}
			if(ok){
//				printf("%d %d\n", deltaX, deltaY);
				st.insert(make_pair(deltaX, deltaY));
			}
		}
	}

	printf("%d\n", (int) st.size());
	return 0;
}
