#include <iostream>
#include <string>

using namespace std;

bool isAlpha(char c){
	return c >= 'a' && c <= 'z';
}

bool isNum(char c){
	return c >= '0' && c <= '9';
}

int main(){
	ios::sync_with_stdio(0);
	string s1, s2;

	cin >> s1 >> s2;

	int len1 = 0, len2 = 0;

	for(int i = 0; i < s1.size(); ++i)
		len1 += (s1[i] > 0 && s1[i] < 9) ? s1[i] - '0' : 1;
	for(int i = 0; i < s2.size(); ++i)
		len2 += (s2[i] > 0 && s2[i] < 9) ? s2[i] - '0' : 1;

	
	
	int p1 = 0, p2 = 0, moves = 0;
	
	while(p1 < len1 && p2 < len2){
		printf("%d %d\n", p1, p2);
		if(isAlpha(s1[p1]) && isAlpha(s2[p2])){
			if(s1[p1] == s2[p2]){
				++p1; ++p2;
			}
			else{
				++moves;
				if(len1 > len2){
				 	++p1;
					++len2;
				}
				else{
					++p2;
					++len1;
				}
			}
		}
		else if(isNum(s1[p1]) && isNum(s2[p2])){
			moves += 2;
			int diff = abs(s1[p1] - s2[p2]);
			if(s2[p2] > s1[p1]){
				p1++;
				s2[p2] = diff + '0';
			}
			else if(s1[p1] == s2[p2]){
				p1++; p2++;
			}
			else{
				p2++;
				s1[p1] = diff + '0';
			}
		}
		else if(isNum(s1[p1]) && isAlpha(s2[p2])){
			++moves;
			--len1;

			for(int i = 0; i < s1[p1] - '0'; ++i){
				if(isNum(s2[p2])){
					--moves;
--p1;
					break;
				}
				p2++;
				++len1;
			}
++p1;
		}
		else{
			++moves;
			--len2;
			for(int i = 0; i < s2[p2] - '0'; ++i){
				if(isNum(s1[p1])){
					--moves;
--p2;
					break;
				}
				p1++;
				++len2;
			}
++p2;
		}

	}

	printf("len1=%d len2=%d p1=%d p2=%d moves=%d\n", len1, len2, p1, p2, moves);

	if(len1 == len2){}
	else if(p1 == len1){
		moves += s2.size() - p2;
	}
	else{
		moves += s1.size() - p1;
	}

	cout << moves << endl;

	
	return 0;
}
